<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();

function GetField($arVars){ 
    $nameField = "";
    $simpleCondition = array(
        'CLASS_ID' => 'CondGroup', 
        'DATA' => array(
            'All'=>'AND',
            'True' => 'True'
        ),
        'CHILDREN' => array(
            array(
                'CLASS_ID'=>$arVars['CLASS_ID'],
                'DATA' => array(
                    'logic'=>'Equal',
                    'value' => $arVars['CONDITION_VALUE']
                )

            )
        )
    );
    $field = $arVars['OB_COND']->GetConditionValues($simpleCondition);
    foreach ($field as $key => $value) {
       $nameField = $value['FIELD']; 
    }        
    unset($field);
    if(stripos($arVars['CLASS_ID'],'CondIBProp:')!== false){            
        $field = explode(":",$arVars['CLASS_ID']);
        if($field[1]==$arVars['IBLOCK_ID']){
            $whoIs="product";
        }
        else{
            $whoIs = "offers";
        }
        $nameFieldTemp = explode("_",$nameField);
        unset($nameFieldTemp[2]);
        $nameField = implode("_",$nameFieldTemp);            
    }
    else{
        $whoIs = 'product';            
    }
    return array('WHO'=>$whoIs, 'NAME'=>$nameField);
}    

function MakeFilter($arVars){
    $conditions = $arVars['CONDITIONS'];
    $catalogInfo = $arVars['CATALOG_INFO'];    
    $logicOperators = array(
        "Equal"=>array('True'=>'=','False'=>'!='),
        "Great"=>array('True'=>'>','False'=>'<='),
        "Not"=>array('True'=>'!=','False'=>'='),
        "Less"=>array('True'=>'<','False'=>'>='),
        "EqGr"=>array('True'=>'>=','False'=>'<'),
        "EqLs"=>array('True'=>'<=','False'=>'>'),
        "Contain"=>array('True'=>'','False'=>'!')
    );
    foreach ($conditions['CHILDREN'] as $key => $children) {            
        $arrFilter['LOGIC']=$conditions['DATA']['All'];
        if ($children['CLASS_ID']=='CondGroup'){ 
            $arrFilter[] = MakeFilter(
                array(
                    "CONDITIONS" => $children, 
                    "OB_COND" => $arVars["OB_COND"],
                    "CATALOG_INFO" => $catalogInfo,                    
                ) 
            );
        }
        else{
            $logic = $logicOperators[$children['DATA']['logic']][$conditions['DATA']['True']];
            $field = GetField(
                array(
                    "OB_COND" => $arVars["OB_COND"], 
                    "CLASS_ID" => $children['CLASS_ID'], 
                    'CONDITION_VALUE' => $children['DATA']['value'],
                    'IBLOCK_ID'=> $catalogInfo['IBLOCK_ID']
                )
            );
            if($field["NAME"] != ""){
                if($field['WHO'] =='offers'){ 
                    $filterSubQuery =  array(
                            "IBLOCK_ID" => $catalogInfo['OFFERS_IBLOCK_ID'],
                            $logic.$field['NAME'] => $children['DATA']['value']                        
                        );                                                                               
                   $arrFilter[]['=ID']=CIBlockElement::SubQuery(
                        "PROPERTY_".$catalogInfo['OFFERS_PROPERTY_ID'], 
                        $filterSubQuery
                    ); 
                }                
                elseif($field['NAME'] == 'SECTION_ID'){
                    $arrFilterTemp[$logic.$field['NAME']][] = $children['DATA']['value'];
                    $arrFilterTemp['INCLUDE_SUBSECTIONS'] = "Y";
                    $arrFilter[] = $arrFilterTemp;
                    unset($arrFilterTemp);                    
                }
                elseif(($field['NAME'] == 'NAME')and ($catalogInfo["OFFERS_IBLOCK_ID"] != "")){
                    $filterSubQuery =  array(
                            "IBLOCK_ID" => $catalogInfo['OFFERS_IBLOCK_ID'],
                            $logic.$field['NAME'] => "%".$children['DATA']['value']."%"                       
                        );                                                                               
                    $arrFilter[]['=ID']=CIBlockElement::SubQuery(
                            "PROPERTY_".$catalogInfo['OFFERS_PROPERTY_ID'], 
                            $filterSubQuery
                    ); 
                }
                elseif ($field['NAME'] == 'NAME') {
                    if($arrFilter['LOGIC']=='OR'){
                        $arrFilter[$logic.$field['NAME']][] = "%".$children['DATA']['value']."%"; 
                    }
                    else{
                        $arrFilter[][$logic.$field['NAME']] = "%".$children['DATA']['value']."%"; 
                    }  
                }
                else{
                    if($arrFilter['LOGIC']=='OR'){
                        $arrFilter[$logic.$field['NAME']][] = $children['DATA']['value'];
                    }
                    else{
                        $arrFilter[][$logic.$field['NAME']] = $children['DATA']['value'];
                    }                    
                }
            }
            
        }
    }      
    if(count($arrFilter)==2){
        unset($arrFilter['LOGIC']);
        if(array_key_exists(0, $arrFilter)){
            $arrFilter=$arrFilter[0];
        }
    }    
    
    return $arrFilter;
}
?>